/**
 Trivial porthreads program: privatized count, with shift
 Orion Sky Lawlor, olawlor@acm.org, 2005/2/7 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include "osl/porthread.h"
#include "osl/porthread.cpp" /*<- for easier linking */

/* Describes a range of numbers to count */
struct number_range {
	int lo, hi;
	int count;
};

void count_range(number_range *n) {
	for (int i=n->lo;i<n->hi;i++) 
		if ((i%2)==0) {
			n->count++; /* i is even-- add it to the count */
		}
}

int main() {
	number_range An;
	char padding[1024]; /* keeps An and Bn on separate cache lines */
	number_range Bn;
	An.lo=0;
	An.hi=Bn.lo=5000000;
	Bn.hi=10000000;
	An.count=Bn.count=0;
	
	porthread_t p=porthread_create((porthread_fn_t)count_range,&An);
	count_range(&Bn);
	porthread_wait(p);
	printf("Total count: %d\n",An.count+Bn.count);
	return 0;
}
